//+------------------------------------------------------------------+
//|                                         me_Breakeven_Line v1.mq4 |
//|                                       Copyright  2016, qK Code. |
//|                                       http://qkcode.blogspot.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2016, qK Code. (http://qkcode.blogspot.com)"
#property link      "http://qkcode.blogspot.com"

#property indicator_chart_window

extern color Buy_BE_Level_Color = Blue;
extern color Sell_BE_Level_Color = Green;
extern int Line_Width = 3;

extern int Text_Corner_0_to_3 = 1;
extern int Text_X_Distance = 5;
extern int Long_Text_Y_Distance = 14;
extern int Short_Text_Y_Distance = 30;

int init()
{
  ObjectDelete ("BreakEven_Sell_Level");
  ObjectDelete ("BreakEven_Buy_Level");
  ObjectDelete ("Pips_To_Sell_BE");
  ObjectDelete ("Pips_To_Buy_BE");
  
  ObjectCreate ("Pips_To_Buy_BE",  OBJ_LABEL, 0, 0, 0);
  ObjectCreate ("Pips_To_Sell_BE", OBJ_LABEL, 0, 0, 0);
  return(0);
}

int deinit()
{
   ObjectDelete ("BreakEven_Sell_Level");
   ObjectDelete ("BreakEven_Buy_Level");
   ObjectDelete ("Pips_To_Sell_BE");
   ObjectDelete ("Pips_To_Buy_BE");
   return(0);
}

int start()
  {
   // Pekali =================================================================================
   double Pekali;
   double Gigits = MarketInfo (Symbol(), MODE_DIGITS);
   if (Gigits == 2) Pekali = 100;
   if (Gigits == 3) Pekali = 100;
   if (Gigits == 4) Pekali = 10000;
   if (Gigits == 5) Pekali = 10000;
   
   // Buy Open Order Count ===================================================================
   int orders_buy = 0;
   int total_buy  = OrdersTotal();
   for (int j_buy  = 0; j_buy < total_buy; j_buy++)
      {
       OrderSelect (j_buy, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol() == Symbol() && OrderType() == OP_BUY) orders_buy++;
      }

   // Sell Open Order Count
   int orders_sell = 0;
   int total_sell  = OrdersTotal();
   for (int j_sell  = 0; j_sell < total_sell; j_sell++)
      {
       OrderSelect (j_sell, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol() == Symbol() && OrderType() == OP_SELL) orders_sell++;
      }

   // Total Orders ===========================================================================
   int orders = orders_buy + orders_sell;
   double Overall_BE_Price = 0;
   double Sel_BE_Price = 0;
   double Cons_Sell_Price = 0;
   double Total_Sell_Size = 0;
   double Buy_BE_Price = 0;
   double Cons_Buy_Price = 0;
   double Total_Buy_Size = 0;
   double Overall_Size = 0;
   int i;
   
   for (i = 0; i < OrdersTotal(); i++)
      {
       OrderSelect (i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol() == Symbol())
         {
          if (OrderType() == OP_BUY)
            {
             Buy_BE_Price += OrderOpenPrice()*OrderLots();
             Total_Buy_Size += OrderLots();
            }
          if (OrderType() == OP_SELL)
            {
             Sel_BE_Price += OrderOpenPrice()*OrderLots();
             Total_Sell_Size += OrderLots();
            }
          if (OrderType() == OP_SELL || OrderType() == OP_BUY)
            {
             Overall_BE_Price += OrderOpenPrice()*OrderLots();
             Overall_Size += OrderLots();
            }            
      }
   }
   
   ObjectDelete("BreakEven_Buy_Level");
   ObjectDelete("BreakEven_Sell_Level");
   
   if (Buy_BE_Price > 0)
     {
      Buy_BE_Price /= Total_Buy_Size;
      ObjectCreate("BreakEven_Buy_Level", OBJ_HLINE, 0, 0, Buy_BE_Price);
      ObjectSet("BreakEven_Buy_Level", OBJPROP_COLOR, Buy_BE_Level_Color);
      ObjectSet("BreakEven_Buy_Level", OBJPROP_WIDTH, Line_Width);
      ObjectSet("BreakEven_Buy_Level", OBJPROP_BACK, false);
     }
     
   if (Sel_BE_Price > 0)
     {
      Sel_BE_Price /= Total_Sell_Size;
      ObjectCreate("BreakEven_Sell_Level", OBJ_HLINE, 0, 0, Sel_BE_Price);
      ObjectSet("BreakEven_Sell_Level", OBJPROP_COLOR, Sell_BE_Level_Color);
      ObjectSet("BreakEven_Sell_Level", OBJPROP_WIDTH, Line_Width);
      ObjectSet("BreakEven_Sell_Level", OBJPROP_BACK, false);
     }
  
   string Buy_Sign;
   color Buy_Color;
   double Buy_Pips_To_BE  = (Bid - Buy_BE_Price)*Pekali;
   if (orders_buy > 0 && Buy_Pips_To_BE >= 0) {Buy_Sign = "+";Buy_Color = Green;}
   if (orders_buy > 0 && Buy_Pips_To_BE < 0)  {Buy_Sign = ""; Buy_Color = Red;}
   if (orders_buy <= 0) {Buy_Sign = ""; Buy_Color = Silver; Buy_Pips_To_BE  = 0;}
   ObjectSet ("Pips_To_Buy_BE", OBJPROP_CORNER, Text_Corner_0_to_3);
   ObjectSet ("Pips_To_Buy_BE", OBJPROP_XDISTANCE, Text_X_Distance);
   ObjectSet ("Pips_To_Buy_BE", OBJPROP_YDISTANCE, Long_Text_Y_Distance);
   ObjectSet ("Pips_To_Buy_BE", OBJPROP_COLOR, Buy_Color);
   ObjectSet ("Pips_To_Buy_BE", OBJPROP_BACK, false);
   ObjectSetText ("Pips_To_Buy_BE", StringConcatenate (Buy_Sign, NormalizeDouble (Buy_Pips_To_BE, 1), "p BEB"), 14, "Arial Bold");
   
   string Sell_Sign;
   color Sell_Color;
   double Sell_Pips_To_BE = (Sel_BE_Price - Ask)*Pekali;
   if (orders_sell > 0 && Sell_Pips_To_BE >= 0) {Sell_Sign = "+";Sell_Color = Green;}
   if (orders_sell > 0 && Sell_Pips_To_BE < 0)  {Sell_Sign = ""; Sell_Color = Red;}
   if (orders_sell <= 0) {Sell_Sign = ""; Sell_Color = Silver; Sell_Pips_To_BE = 0;}
   ObjectSet ("Pips_To_Sell_BE", OBJPROP_CORNER, Text_Corner_0_to_3);
   ObjectSet ("Pips_To_Sell_BE", OBJPROP_XDISTANCE, Text_X_Distance);
   ObjectSet ("Pips_To_Sell_BE", OBJPROP_YDISTANCE, Short_Text_Y_Distance);
   ObjectSet ("Pips_To_Sell_BE", OBJPROP_COLOR, Sell_Color);
   ObjectSet ("Pips_To_Sell_BE", OBJPROP_BACK, false);
   ObjectSetText ("Pips_To_Sell_BE", StringConcatenate (Sell_Sign, NormalizeDouble (Sell_Pips_To_BE, 1), "p BES"), 14, "Arial Bold");
     
   return(0);
  }